﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=6.3
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: True
#End Region

Sub Process_Globals
	Dim admin As BluetoothAdmin
	Dim serial1 As Serial
	Dim foundDevices As Map
	Type NameAndMac (Name As String, Mac As String)
	Dim connectedDevice As NameAndMac
End Sub

Sub Globals
	Dim btnSearchForDevices As Button
	Dim btnDeleteDevices As Button
	Dim btnDone As Button
	Dim lblCurrentDevice As Label
	Dim lstBT As List
End Sub

Sub Activity_Create(FirstTime As Boolean)

	If FirstTime Then
		admin.Initialize("admin")
		serial1.Initialize("serial1")
	End If

	Activity.LoadLayout("configbt")

End Sub

Sub Activity_Resume
	
	ShowDevices

	btnSearchForDevices.Enabled = False

	If admin.IsEnabled = False Then
		If admin.Enable = False Then
			ToastMessageShow("Error enabling Bluetooth adapter.", True)
		Else
			ToastMessageShow("Enabling Bluetooth adapter...", False)
		End If
	Else
		Admin_StateChanged(admin.STATE_ON, 0)
	End If

End Sub

Sub Admin_StateChanged (NewState As Int, OldState As Int)
	btnSearchForDevices.Enabled = (NewState = admin.STATE_ON)
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed = True Then
		serial1.Disconnect
	End If
End Sub

Sub btnSearchForDevices_Click

	foundDevices.Initialize

	If admin.StartDiscovery	= False Then
		ToastMessageShow("Error starting discovery process.", True)
	Else
		ProgressDialogShow("Searching for devices...")
	End If

End Sub

Sub Admin_DeviceFound (Name As String, MacAddress As String)

	Log("device found " & Name & " : " & MacAddress)

	Dim mapValue As NameAndMac
	mapValue.Name = Name
	mapValue.Mac = MacAddress
	foundDevices.Put(Name, mapValue)

End Sub

Sub Admin_DiscoveryFinished

	ProgressDialogHide

	If foundDevices.Size = 0 Then
		ToastMessageShow("No device found.", True)
	Else
	
		Private lstFound As List
		lstFound.Initialize
		
		For Each nm As NameAndMac In foundDevices.Values
			lstFound.Add(nm.name)
		Next

		InputListAsync(lstFound, "Choose device to connect", -1, True)
		Wait For InputList_Result (res As Int)

		If res <> DialogResponse.CANCEL Then
			Log("selected device name = " & lstFound.Get(res))
			connectedDevice = foundDevices.GetValueAt(res)
			ProgressDialogShow("Trying to connect to: " & connectedDevice.Name & " (" & connectedDevice.Mac & ")")
			serial1.Connect(connectedDevice.mac)
		End If

	End If

End Sub

Sub Serial1_Connected (Success As Boolean)

	ProgressDialogHide

	If Success = False Then
		Log(LastException.Message)
		ToastMessageShow("Error connecting: " & LastException.Message, True)
	Else
		lstBT.Add( connectedDevice.Mac )
		File.WriteList( File.DirDefaultExternal, "BT-Vemco-FieldReader.txt", lstBT )
		Log("Stored to external file: " & connectedDevice.Mac)
		ShowDevices
		ToastMessageShow( "Bluetooth Configuration Saved", False )
		serial1.Disconnect
	End If

End Sub
Sub btnDeleteDevices_Click

	If lstBT.Size > 0 Then
		For i = 0 To lstBT.Size - 1
			UnpairDevice(lstBT.Get(i))
		Next
	End If

	If File.Exists( File.DirDefaultExternal, "BT-Vemco-FieldReader.txt" ) Then
		File.Delete(File.DirDefaultExternal, "BT-Vemco-FieldReader.txt")
		lstBT.Initialize
	End If

	ShowDevices

	ToastMessageShow( "Bluetooth Devices Removed", False )

End Sub

Sub UnpairDevice(Address As String)

	Dim adapter As JavaObject
	adapter = adapter.InitializeStatic("android.bluetooth.BluetoothAdapter").RunMethod("getDefaultAdapter", Null)
	Dim device As JavaObject = adapter.RunMethod("getRemoteDevice", Array(Address))
	Log(device.RunMethod("removeBond", Null))

End Sub

Sub btnDone_Click

	serial1.Disconnect
	Activity.Finish

End Sub

Sub ShowDevices


	If File.Exists( File.DirDefaultExternal, "BT-Vemco-FieldReader.txt" ) Then
					
		Private DeviceList = "" As String
		Private FoundThisOne = False As Boolean

		serial1.Initialize("serial1")
		Private PairedDevices As Map
		PairedDevices = serial1.GetPairedDevices

		lstBT = File.ReadList(File.DirDefaultExternal, "BT-Vemco-FieldReader.txt")

		For i = 0 To lstBT.Size - 1
			For pd = 0 To PairedDevices.Size - 1
				If PairedDevices.GetValueAt(pd) = lstBT.Get(i) Then
					DeviceList = DeviceList & PairedDevices.GetKeyAt(pd) & " (" & lstBT.Get(i) & ")" & CRLF
					FoundThisOne = True
				End If
			Next
			If FoundThisOne = False Then
				DeviceList = DeviceList & "Unpaired device at " & lstBT.Get(i) & CRLF
			End If
		Next

		lblCurrentDevice.Text = "Current Device(s): " & CRLF & CRLF & DeviceList

	Else
		
		lstBT.Initialize
		lblCurrentDevice.Text = "No Devices"
		
	End If

End Sub
